diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
index ad2fda1caa..83b4c8f94f 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
@@ -2220,31 +2758,6 @@ setup_wc_kstats(struct adapter *sc)
 	return (ksp);
 }
 
-static int
-update_wc_kstats(kstat_t *ksp, int rw)
-{
-	struct t4_wc_kstats *kstatp = (struct t4_wc_kstats *)ksp->ks_data;
-	struct adapter *sc = ksp->ks_private;
-	uint32_t wc_total, wc_success, wc_failure;
-
-	if (rw == KSTAT_WRITE)
-		return (0);
-
-	if (t4_cver_ge(sc, CHELSIO_T5)) {
-		wc_total = t4_read_reg(sc, A_SGE_STAT_TOTAL);
-		wc_failure = t4_read_reg(sc, A_SGE_STAT_MATCH);
-		wc_success = wc_total - wc_failure;
-	} else {
-		wc_success = 0;
-		wc_failure = 0;
-	}
-
-	KS_U_SET(write_coal_success, wc_success);
-	KS_U_SET(write_coal_failure, wc_failure);
-
-	return (0);
-}
-
 /*
  * cxgbe:X:fec
  *
@@ -2272,21 +2785,18 @@ struct cxgbe_port_fec_kstats {
 };
 
 static uint32_t
-read_fec_pair(struct port_info *pi, uint32_t lo_reg, uint32_t high_reg)
+t4_read_fec_pair(struct port_info *pi, uint32_t lo_reg, uint32_t high_reg)
 {
 	struct adapter *sc = pi->adapter;
-	uint8_t port = pi->tx_chan;
-	uint32_t low, high, ret;
+	const uint8_t port = pi->tx_chan;
 
-	low = t4_read_reg(sc, T5_PORT_REG(port, lo_reg));
-	high = t4_read_reg(sc, T5_PORT_REG(port, high_reg));
-	ret = low & 0xffff;
-	ret |= (high & 0xffff) << 16;
-	return (ret);
+	const uint32_t low = t4_read_reg(sc, T5_PORT_REG(port, lo_reg));
+	const uint32_t high = t4_read_reg(sc, T5_PORT_REG(port, high_reg));
+	return ((low & 0xffff) | ((high & 0xffff) << 16));
 }
 
 static int
-update_port_fec_kstats(kstat_t *ksp, int rw)
+t4_update_fec_kstats(kstat_t *ksp, int rw)
 {
 	struct cxgbe_port_fec_kstats *fec = ksp->ks_data;
 	struct port_info *pi = ksp->ks_private;
@@ -2298,44 +2808,44 @@ update_port_fec_kstats(kstat_t *ksp, int rw)
 	/*
 	 * First go ahead and gather RS related stats.
 	 */
-	fec->rs_corr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_CCW_LO,
-	    T6_RS_FEC_CCW_HI);
-	fec->rs_uncorr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_NCCW_LO,
-	    T6_RS_FEC_NCCW_HI);
-	fec->rs_sym0_corr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_SYMERR0_LO,
-	    T6_RS_FEC_SYMERR0_HI);
-	fec->rs_sym1_corr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_SYMERR1_LO,
-	    T6_RS_FEC_SYMERR1_HI);
-	fec->rs_sym2_corr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_SYMERR2_LO,
-	    T6_RS_FEC_SYMERR2_HI);
-	fec->rs_sym3_corr.value.ui64 += read_fec_pair(pi, T6_RS_FEC_SYMERR3_LO,
-	    T6_RS_FEC_SYMERR3_HI);
+	fec->rs_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_CCW_LO, T6_RS_FEC_CCW_HI);
+	fec->rs_uncorr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_NCCW_LO, T6_RS_FEC_NCCW_HI);
+	fec->rs_sym0_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_SYMERR0_LO, T6_RS_FEC_SYMERR0_HI);
+	fec->rs_sym1_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_SYMERR1_LO, T6_RS_FEC_SYMERR1_HI);
+	fec->rs_sym2_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_SYMERR2_LO, T6_RS_FEC_SYMERR2_HI);
+	fec->rs_sym3_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_RS_FEC_SYMERR3_LO, T6_RS_FEC_SYMERR3_HI);
 
 	/*
 	 * Now go through and try to grab Firecode/BASE-R stats.
 	 */
-	fec->fc_lane0_corr.value.ui64 += read_fec_pair(pi, T6_FC_FEC_L0_CERR_LO,
-	    T6_FC_FEC_L0_CERR_HI);
-	fec->fc_lane0_uncorr.value.ui64 += read_fec_pair(pi,
-	    T6_FC_FEC_L0_NCERR_LO, T6_FC_FEC_L0_NCERR_HI);
-	fec->fc_lane1_corr.value.ui64 += read_fec_pair(pi, T6_FC_FEC_L1_CERR_LO,
-	    T6_FC_FEC_L1_CERR_HI);
-	fec->fc_lane1_uncorr.value.ui64 += read_fec_pair(pi,
-	    T6_FC_FEC_L1_NCERR_LO, T6_FC_FEC_L1_NCERR_HI);
-	fec->fc_lane2_corr.value.ui64 += read_fec_pair(pi, T6_FC_FEC_L2_CERR_LO,
-	    T6_FC_FEC_L2_CERR_HI);
-	fec->fc_lane2_uncorr.value.ui64 += read_fec_pair(pi,
-	    T6_FC_FEC_L2_NCERR_LO, T6_FC_FEC_L2_NCERR_HI);
-	fec->fc_lane3_corr.value.ui64 += read_fec_pair(pi, T6_FC_FEC_L3_CERR_LO,
-	    T6_FC_FEC_L3_CERR_HI);
-	fec->fc_lane3_uncorr.value.ui64 += read_fec_pair(pi,
-	    T6_FC_FEC_L3_NCERR_LO, T6_FC_FEC_L3_NCERR_HI);
+	fec->fc_lane0_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L0_CERR_LO, T6_FC_FEC_L0_CERR_HI);
+	fec->fc_lane0_uncorr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L0_NCERR_LO, T6_FC_FEC_L0_NCERR_HI);
+	fec->fc_lane1_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L1_CERR_LO, T6_FC_FEC_L1_CERR_HI);
+	fec->fc_lane1_uncorr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L1_NCERR_LO, T6_FC_FEC_L1_NCERR_HI);
+	fec->fc_lane2_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L2_CERR_LO, T6_FC_FEC_L2_CERR_HI);
+	fec->fc_lane2_uncorr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L2_NCERR_LO, T6_FC_FEC_L2_NCERR_HI);
+	fec->fc_lane3_corr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L3_CERR_LO, T6_FC_FEC_L3_CERR_HI);
+	fec->fc_lane3_uncorr.value.ui64 +=
+	    t4_read_fec_pair(pi, T6_FC_FEC_L3_NCERR_LO, T6_FC_FEC_L3_NCERR_HI);
 
 	return (0);
 }
 
 static kstat_t *
-setup_port_fec_kstats(struct port_info *pi)
+t4_init_fec_kstats(struct port_info *pi)
 {
 	kstat_t *ksp;
 	struct cxgbe_port_fec_kstats *kstatp;
@@ -2354,22 +2864,22 @@ setup_port_fec_kstats(struct port_info *pi)
 	}
 
 	kstatp = ksp->ks_data;
-	KS_U64INIT(rs_corr);
-	KS_U64INIT(rs_uncorr);
-	KS_U64INIT(rs_sym0_corr);
-	KS_U64INIT(rs_sym1_corr);
-	KS_U64INIT(rs_sym2_corr);
-	KS_U64INIT(rs_sym3_corr);
-	KS_U64INIT(fc_lane0_corr);
-	KS_U64INIT(fc_lane0_uncorr);
-	KS_U64INIT(fc_lane1_corr);
-	KS_U64INIT(fc_lane1_uncorr);
-	KS_U64INIT(fc_lane2_corr);
-	KS_U64INIT(fc_lane2_uncorr);
-	KS_U64INIT(fc_lane3_corr);
-	KS_U64INIT(fc_lane3_uncorr);
-
-	ksp->ks_update = update_port_fec_kstats;
+	KS_INIT_U64(kstatp, rs_corr);
+	KS_INIT_U64(kstatp, rs_uncorr);
+	KS_INIT_U64(kstatp, rs_sym0_corr);
+	KS_INIT_U64(kstatp, rs_sym1_corr);
+	KS_INIT_U64(kstatp, rs_sym2_corr);
+	KS_INIT_U64(kstatp, rs_sym3_corr);
+	KS_INIT_U64(kstatp, fc_lane0_corr);
+	KS_INIT_U64(kstatp, fc_lane0_uncorr);
+	KS_INIT_U64(kstatp, fc_lane1_corr);
+	KS_INIT_U64(kstatp, fc_lane1_uncorr);
+	KS_INIT_U64(kstatp, fc_lane2_corr);
+	KS_INIT_U64(kstatp, fc_lane2_uncorr);
+	KS_INIT_U64(kstatp, fc_lane3_corr);
+	KS_INIT_U64(kstatp, fc_lane3_uncorr);
+
+	ksp->ks_update = t4_update_fec_kstats;
 	ksp->ks_private = pi;
 	kstat_install(ksp);
 
@@ -2380,43 +2890,42 @@ int
 t4_port_full_init(struct port_info *pi)
 {
 	struct adapter *sc = pi->adapter;
-	uint16_t *rss;
 	struct sge_rxq *rxq;
 	int rc, i;
 
 	ASSERT((pi->flags & TPF_INIT_DONE) == 0);
 
-	/*
-	 * Allocate tx/rx/fl queues for this port.
-	 */
-	rc = t4_setup_port_queues(pi);
-	if (rc != 0)
-		goto done;	/* error message displayed already */
+	/* Allocate TX/RX/FL queues for this port. */
+	if ((rc = t4_port_queues_init(pi)) != 0) {
+		goto done;
+	}
 
-	/*
-	 * Setup RSS for this port.
-	 */
-	rss = kmem_zalloc(pi->nrxq * sizeof (*rss), KM_SLEEP);
+	/* Setup RSS for this port. */
+	uint16_t *rss = kmem_zalloc(pi->rxq_count * sizeof (*rss), KM_SLEEP);
 	for_each_rxq(pi, i, rxq) {
-		rss[i] = rxq->iq.abs_id;
+		rss[i] = rxq->iq.tsi_abs_id;
 	}
 	rc = -t4_config_rss_range(sc, sc->mbox, pi->viid, 0,
-	    pi->rss_size, rss, pi->nrxq);
-	kmem_free(rss, pi->nrxq * sizeof (*rss));
+	    pi->rss_size, rss, pi->rxq_count);
+	kmem_free(rss, pi->rxq_count * sizeof (*rss));
 	if (rc != 0) {
 		cxgb_printf(pi->dip, CE_WARN, "rss_config failed: %d", rc);
 		goto done;
 	}
 
-	/*
-	 * Initialize our per-port FEC kstats.
-	 */
-	pi->ksp_fec = setup_port_fec_kstats(pi);
+	t4_port_kstats_init(pi);
+	pi->ksp_fec = t4_init_fec_kstats(pi);
 
 	pi->flags |= TPF_INIT_DONE;
+
 done:
-	if (rc != 0)
-		(void) t4_port_full_uninit(pi);
+	if (rc != 0) {
+		/*
+		 * Clean up any state resulting which may be lingering due to
+		 * failure part way through initialization.
+		 */
+		t4_port_full_uninit(pi);
+	}
 
 	return (rc);
 }
@@ -2424,83 +2933,16 @@ done:
 /*
  * Idempotent.
  */
-static int
+static void
 t4_port_full_uninit(struct port_info *pi)
 {
-
-	ASSERT(pi->flags & TPF_INIT_DONE);
-
 	if (pi->ksp_fec != NULL) {
 		kstat_delete(pi->ksp_fec);
 		pi->ksp_fec = NULL;
 	}
-	(void) t4_teardown_port_queues(pi);
+	t4_port_kstats_fini(pi);
+	t4_port_queues_fini(pi);
 	pi->flags &= ~TPF_INIT_DONE;
-
-	return (0);
-}
-
-void
-t4_port_queues_enable(struct port_info *pi)
-{
-	ASSERT(pi->flags & TPF_INIT_DONE);
-
-	/*
-	 * TODO: whatever was queued up after we set iq->state to IQS_DISABLED
-	 * back in t4_port_queues_disable will be processed now, after an
-	 * unbounded delay.  This can't be good.
-	 */
-
-	int i;
-	struct adapter *sc = pi->adapter;
-	struct sge_rxq *rxq;
-
-	mutex_enter(&sc->sfl_lock);
-	for_each_rxq(pi, i, rxq) {
-		struct sge_iq *iq = &rxq->iq;
-
-		if (atomic_cas_uint(&iq->state, IQS_DISABLED, IQS_IDLE) !=
-		    IQS_DISABLED)
-			panic("%s: iq %p wasn't disabled", __func__,
-			    (void *) iq);
-
-		/*
-		 * Freelists which were marked "doomed" by a previous
-		 * t4_port_queues_disable() call should clear that status.
-		 */
-		rxq->fl.flags &= ~FL_DOOMED;
-
-		t4_iq_gts_update(iq, iq->intr_params, 0);
-
-	}
-	mutex_exit(&sc->sfl_lock);
-}
-
-void
-t4_port_queues_disable(struct port_info *pi)
-{
-	int i;
-	struct adapter *sc = pi->adapter;
-	struct sge_rxq *rxq;
-
-	ASSERT(pi->flags & TPF_INIT_DONE);
-
-	/*
-	 * TODO: need proper implementation for all tx queues (ctrl, eth, ofld).
-	 */
-
-	for_each_rxq(pi, i, rxq) {
-		while (atomic_cas_uint(&rxq->iq.state, IQS_IDLE,
-		    IQS_DISABLED) != IQS_IDLE)
-			msleep(1);
-	}
-
-	mutex_enter(&sc->sfl_lock);
-	for_each_rxq(pi, i, rxq) {
-		rxq->fl.flags |= FL_DOOMED;
-	}
-	mutex_exit(&sc->sfl_lock);
-	/* TODO: need to wait for all fl's to be removed from sc->sfl */
 }
 
 void
@@ -2568,6 +3010,91 @@ t4_os_set_hw_addr(struct adapter *sc, int idx, const uint8_t *hw_addr)
 	bcopy(hw_addr, sc->port[idx]->hw_addr, ETHERADDRL);
 }
 
+/* Add thread to list of consumers waiting to access adapter mailbox */
+void
+t4_mbox_waiter_add(struct adapter *sc, t4_mbox_waiter_t *ent)
+{
+	mutex_enter(&sc->mbox_lock);
+	ent->thread = curthread;
+	list_insert_tail(&sc->mbox_list, ent);
+	mutex_exit(&sc->mbox_lock);
+}
+
+/* Remove thread from list of consumers waiting to access adapter mailbox */
+void
+t4_mbox_waiter_remove(struct adapter *sc, t4_mbox_waiter_t *ent)
+{
+	ASSERT(ent->thread == curthread);
+
+	mutex_enter(&sc->mbox_lock);
+	const bool was_owner = (list_head(&sc->mbox_list) == ent);
+	list_remove(&sc->mbox_list, ent);
+
+	if (was_owner && !list_is_empty(&sc->mbox_list)) {
+		/*
+		 * Wake the other threads waiting on the mbox as we are vacating
+		 * the "owner" slot.
+		 */
+		cv_broadcast(&sc->mbox_cv);
+	}
+	mutex_exit(&sc->mbox_lock);
+}
+
+/*
+ * Wait for the current thread, which has called t4_mbox_waiter_add(), to become
+ * the "owner" of the adapter mailbox (head of the waiter list).
+ *
+ * Returns true if current thread is the owner, else false if we slept/spun for
+ * `wait_us` and are not yet owner (and thus should recheck adapter status).
+ */
+bool
+t4_mbox_wait_owner(struct adapter *sc, uint_t wait_us, bool sleep_ok)
+{
+	mutex_enter(&sc->mbox_lock);
+	t4_mbox_waiter_t *head = list_head(&sc->mbox_list);
+	ASSERT(head != NULL);
+
+	if (head->thread == curthread) {
+		mutex_exit(&sc->mbox_lock);
+		return (true);
+	}
+
+	if (!sleep_ok) {
+		mutex_exit(&sc->mbox_lock);
+		drv_usecwait(wait_us);
+
+		mutex_enter(&sc->mbox_lock);
+		head = list_head(&sc->mbox_list);
+		ASSERT(head != NULL);
+		bool is_owner = head->thread == curthread;
+		mutex_exit(&sc->mbox_lock);
+		return (is_owner);
+	}
+
+	/*
+	 * Using a singal-aware wait would be more courteous here, but much of
+	 * the logic which ultimately accesses the device mbox is ill-equipped
+	 * to handle gracefully EINTR failures.
+	 */
+	const int res = cv_reltimedwait(&sc->mbox_cv, &sc->mbox_lock,
+	    USEC_TO_TICK(wait_us), TR_MICROSEC);
+	if (res > 0) {
+		head = list_head(&sc->mbox_list);
+		ASSERT(head != NULL);
+		if (head->thread == curthread) {
+			/*
+			 * CV was signaled and this thread now occupies the head
+			 * of the list (indicating mbox ownership).
+			 */
+			mutex_exit(&sc->mbox_lock);
+			return (true);
+		}
+	}
+	mutex_exit(&sc->mbox_lock);
+	return (false);
+}
+
+
 uint32_t
 t4_read_reg(struct adapter *sc, uint32_t reg)
 {
@@ -2790,16 +3317,12 @@ t4_cxgbe_attach(struct port_info *pi, dev_info_t *dip)
 	mac->m_driver = pi;
 	mac->m_dip = dip;
 	mac->m_src_addr = pi->hw_addr;
-	mac->m_callbacks = pi->mc;
+	mac->m_callbacks = &t4_mac_callbacks;
 	mac->m_max_sdu = pi->mtu;
 	/* mac_register() treats this as const, so we can cast it away */
 	mac->m_priv_props = (char **)props;
 	mac->m_margin = VLAN_TAGSZ;
-
-	if (!mac->m_callbacks->mc_unicst) {
-		/* Multiple rings enabled */
-		mac->m_v12n = MAC_VIRT_LEVEL1;
-	}
+	mac->m_v12n = MAC_VIRT_LEVEL1;
 
 	mac_handle_t mh = NULL;
 	const int rc = mac_register(mac, &mh);
